------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Grand Magus Telestra"]

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

local split1announced = nil
local split2announced = nil
local difficulty

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Telestra",
	merge_message = "Merged",
	merge_trigger = "Now to finish the job!",
	split = "Split",
	split_desc = "Warn when Grand Magus Telestra is about to split.",
	split_message = "Grand Magus Telestra has split",
	split_soon_message = "Spliting Soon",
	split_trigger1 = "There's plenty of me to go around.",
	split_trigger2 = "I'll give you more than you can handle.",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Telestra",
	merge_message = "Fusioniert",
	merge_trigger = "Nun bringen wir's zu Ende!",
	split = "Teilung",
	split_desc = "Warnen, wenn Großmagistrix Telestra sich teilt.",
	split_message = "Großmagistrix Telestra hat sich geteilt",
	split_soon_message = "Teilung bald",
	split_trigger1 = "Ihr wisst ja, was nach Hochmut kommt...",
	split_trigger2 = "Ich teile mehr aus, als ihr verkraften könnt!",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Telestra",
	merge_message = "Fusion",
	merge_trigger = "Et maintenant finissons le travail !",
	split = "Division",
	split_desc = "Prévient quand la Grand magus Telestra est sur le point de se diviser.",
	split_message = "Grand magus Telestra s'est divisée",
	split_soon_message = "Division imminente",
	split_trigger1 = "Il y en aura assez pour tout le monde.",
	split_trigger2 = "Vous allez être trop bien servis !",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "텔레스트라",
	merge_message = "본체 등장!",
	merge_trigger = "이제 슬슬 끝내 주마!",
	split = "분리",
	split_desc = "대마법사 텔레스트라의 분리를 알립니다.",
	split_message = "대마법사 텔레스트라가 분리합니다!",
	split_soon_message = "잠시 후 분리",
	split_trigger1 = "여기엔 내가 참 많지.",
	split_trigger2 = "과연 나를 감당할 수 있겠느냐!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Телестра",
	merge_message = "Слилась",
	merge_trigger = "Ну а теперь, покончим с этим!", -- Needs review
	split = "Разделение",
	split_desc = "Предупреждать о разделении Великой ведуньи Телестры.",
	split_message = "Великая ведунья Телестра разделилась",
	split_soon_message = "Скоро разделение",
	split_trigger1 = "Меня на вас хватит!",
	split_trigger2 = "Вы получите больше, чем заслуживаете!\"",
}

end )

L:RegisterTranslations("zhCN", function() return {
	merge_message = "合体！",
	merge_trigger = "Now to finish the job!",
	split = "分裂",
	split_desc = "当大魔导师泰蕾丝塔施放分裂时发出警报。",
	split_message = "大魔导师泰蕾丝塔 - 分裂！",
	split_soon_message = "即将 分裂！",
	split_trigger1 = "There's plenty of me to go around.",
	split_trigger2 = "I'll give you more than you can handle.",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "特雷斯翠",
	merge_message = "合體！",
	merge_trigger = "Now to finish the job!",
	split = "分裂",
	split_desc = "當大魔導師特雷斯翠施放分裂時發出警報。",
	split_message = "大魔導師特雷斯翠 - 分裂！",
	split_soon_message = "即將 分裂！",
	split_trigger1 = "There's plenty of me to go around.",
	split_trigger2 = "I'll give you more than you can handle.",
}

end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.partyContent = true
mod.otherMenu = "Coldarra"
mod.zonename = BZ["The Nexus"]
mod.enabletrigger = {boss} 
mod.guid = 26731
mod.toggleoptions = {"split", "bosskill"}
mod.revision = tonumber(("$Revision: 554 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("UNIT_DIED", "BossDeath")
	
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
	self:RegisterEvent("UNIT_HEALTH")

	split1announced = nil
	split2announced = nil

	difficulty = GetInstanceDifficulty()
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:UNIT_HEALTH(arg1)
	if not self.db.profile.split then return end
	if UnitName(arg1) == boss then
		local currentHealth = UnitHealth(arg1)
		local maxHealth = UnitHealthMax(arg1)
		local percentHealth = (currentHealth/maxHealth)*100
		if percentHealth > 51 and percentHealth <= 54 and not split1announced then
			self:Message(L["split_soon_message"], "Attention")
			split1announced = true
		elseif difficulty == 2 and not split2announced and perecentHealth > 11 and precentHealth <= 14 then
			self:Message(L["split_soon_message"], "Attention")
			split2announced = true
		elseif percentHealth > 60 and (split1announced or split2announced) then
			split1announced = false
			split2announced = false
		end
	end
end

function mod:CHAT_MSG_MONSTER_YELL(msg)
	if (msg == L["split_trigger1"] or msg == L["split_trigger2"]) then
		if self.db.profile.split then
			self:IfMessage(L["split_message"], "Important", 19569)
		end
	elseif msg == L["merge_trigger"] then
		if self.db.profile.split then
			self:Message(L["merge_message"], "Important")
		end
	end
end

