﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Zuramat the Obliterator"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 543 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.otherMenu = "Dalaran"
mod.zonename = BZ["The Violet Hold"]
mod.enabletrigger = boss 
mod.guid = 29314
mod.toggleoptions = {"voidShift", "voidShiftBar", -1, "darkness", "bosskill"}

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Zuramat",
	darkness = "Shroud of Darkness",
	darkness_desc = "Warns for Shroud of Darkness.",
	darkness_message = "Shroud of Darkness",
	voidShift = "Void Shift",
	voidShiftBar = "Void Shift Bar",
	voidShiftBar_desc = "Display a bar for the duration of Void Shift.",
	voidShift_desc = "Warn when someone has Void Shift.",
	voidShift_other = "Void Shift: %s",
	voidShift_you = "Void Shift on YOU!",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Zuramat",
	darkness = "Umhüllung der Dunkelheit",
	darkness_desc = "Warnung für Umhüllung der Dunkelheit.",
	darkness_message = "Umhüllung der Dunkelheit!",
	voidShift = "Leerenverschiebung",
	voidShiftBar = "Leerenverschiebung-Anzeige",
	voidShiftBar_desc = "Eine Leiste für die Dauer der Leerenverschiebung anzeigen.",
	voidShift_desc = "Warnen wenn jemand von Leerenverschiebung betroffen ist.",
	voidShift_other = "Leerenverschiebung: %s",
	voidShift_you = "Leerenverschiebung auf DIR!",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Zuramat",
	darkness = "Voile de ténèbres",
	darkness_desc = "Prévient quand un Voile de ténèbres est incanté.",
	darkness_message = "Voile de ténèbres",
	voidShift = "Passage dans le Vide",
	voidShiftBar = "Passage dans le Vide - Barre",
	voidShiftBar_desc = "Affiche une barre indiquant la durée du Passage dans le Vide.",
	voidShift_desc = "Prévient quand un joueur subit les effets du Passage dans le Vide.",
	voidShift_other = "Passage dans le Vide : %s",
	voidShift_you = "Passage dans le Vide sur VOUS !",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "주라마트",
	darkness = "어둠의 수의",
	darkness_desc = "어둠의 수의에 대해 알립니다.",
	darkness_message = "어둠의 수의!",
	voidShift = "공허의 전환",
	voidShiftBar = "공허의 전환 바",
	voidShiftBar_desc = "공허의 전환이 지속되는 바를 표시합니다.",
	voidShift_desc = "공허의 전환에 걸린 플레이어를 알립니다.",
	voidShift_other = "공허의 전환: %s",
	voidShift_you = "당신은 공허의 전환!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Зурамат",
	darkness = "Покров Тьмы",
	darkness_desc = "Предупреждать о Покрове Тьмы.",
	darkness_message = "Покров Тьмы!",
	voidShift = "Вхождение в Бездну",
	voidShiftBar = "Полоса Вхождения в Бездну",
	voidShiftBar_desc = "Отображать полосу продолжительности Вхождения в Бездну.",
	voidShift_desc = "Предупреждать, когда кто-нибудь Входит в Бездну.",
	voidShift_other = "%s: входит в бездну!",
	voidShift_you = "Вхождение в Бездну на ВАС!",
}

end )

L:RegisterTranslations("zhCN", function() return {
	darkness = "黑暗遮蔽",
	darkness_desc = "当施放黑暗遮蔽时发出警报。",
	darkness_message = "黑暗遮蔽！",
	voidShift = "虚空转移",
	voidShiftBar = "虚空转移计时条",
	voidShiftBar_desc = "当虚空转移持续时显示计时条。",
	voidShift_desc = "当玩家中了虚空转移时发出警报。",
	voidShift_other = "虚空转移：>%s<！",
	voidShift_you = ">你< 虚空转移！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "舒拉邁特",
	darkness = "黑暗障蔽",
	darkness_desc = "當施放黑暗障蔽時發出警報。",
	darkness_message = "黑暗障蔽！",
	voidShift = "虛空移形",
	voidShiftBar = "虛空移形計時條",
	voidShiftBar_desc = "當虛空移形持續時顯示計時條。",
	voidShift_desc = "當玩家中了虛空移形時發出警報。",
	voidShift_other = "虛空移形：>%s<！",
	voidShift_you = ">你< 虛空移形！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "VoidShift", 54361, 59743)
	self:AddCombatListener("SPELL_AURA_APPLIED", "Darkness", 54524, 59745)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:VoidShift(player, spellId)
	if self.db.profile.voidShift then
		local other = L["voidShift_other"]:format(player)
		if player == pName then
			self:Message(L["voidShift_you"], "Personal", true, "Alert", nil, spellId)
			self:Message(other, "Attention", nil, nil, true)
		else
			self:Message(other, "Attention", nil, nil, nil, spellId)
			self:Whisper(player, L["voidShift_you"])
		end
		self:Icon(player, "icon")
		if self.db.profile.voidShiftBar then
			self:Bar(other, 15, spellId)
		end
	end
end

function mod:Darkness(_, spellId)
	if self.db.profile.darkness then
		self:IfMessage(L["darkness_message"], "Important", spellId)
	end
end
